<?php
/*
	"I wake up in the morning with ideas that please me, and some of
	those ideas actually please me also later in the day when I've
	entered them into my computer."
	  -- Donald Knuth
*/

// All include files are here; there are no classes, no global objects,
// and no nested includes.

define('THIS_EOL',"\n");

$GLOBALS['VERSION'] = '1.3.0';		// gets put into configuration data

include 'error.php';
include 'rules.php';
include 'dat/defines.php';		// MySQL and Admin password defines

foreach (glob('inc/*.php') as $inc)	// include all library functions
	include($inc);

foreach (glob('mod/*.php') as $inc) {	// include all modules
	include($inc);
	$inc = str_replace('mod/','',$inc);
	$init = '_'.str_replace('.php','',$inc);
	if (!function_exists($init))
		$init = NULL;
	setmodule($inc,$init);
}

include "testing.php";	// while in BETA we do this instead of that:
//include "mysql.php";				// database functions
// see file TESTING

$file = html('themedir')."functions.php";	// theme code (optional)
if (is_file($file)) {
	debug("'$file'");
	include $file;
}

modules_init();					// initialize all data

$op = getvar('op');				// $_GET alias

do_rules($op);					// see RULES.PHP

// Do not change anything below this line!
